{
    This file is part of RA1792Control

    RACAL RA1792 Control program

    Copyright (C) 2014-2015 G. Perotti, I1EPJ, i1epj@aricasale.it

    This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program. If not, see <http://www.gnu.org/licenses/.
}

unit ura1792;

{$mode objfpc}{$H+}

{$UNDEF TEST}
{$UNDEF TEST_USER_INTERFACE}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Menus, ExtCtrls, Buttons, ComCtrls, serial, types, LCLType, ActnList, Spin,
  mouse, dateutils, math, user, UAbout, UGNU, UMAN, urxaddr, umanager, uenttestno;

type

  { TRA1792 }

  TRA1792 = class(TForm)
    BSTORE: TButton;
    BENTER: TButton;
    BAM: TBitBtn;
    BTUNE: TBitBtn;
    BRCL: TBitBtn;
    BCHSCAN: TBitBtn;
    BFM: TBitBtn;
    BCW: TBitBtn;
    BCHAN: TButton;
    BLSB: TBitBtn;
    BISB: TBitBtn;
    BFREQ: TBitBtn;
    BUSB: TBitBtn;
    BBFO: TBitBtn;
    BREM: TBitBtn;
    CBMODE: TComboBox;
    CBBW: TComboBox;
    CBAGC: TComboBox;
    CHAN: TStaticText;
    MTIMED: TMenuItem;
    M0P5KHZT: TMenuItem;
    MSTBITE: TMenuItem;
    MSTBITEFM: TMenuItem;
    MOTHER: TMenuItem;
    STBFO1: TStaticText;
    STBFO2: TStaticText;
    STBW1: TStaticText;
    STBW2: TStaticText;
    STBFOFR: TStaticText;
    STBW: TStaticText;
    STFAULT: TStaticText;
    STMUTE: TStaticText;
    STRF: TStaticText;
    STMET: TStaticText;
    STSCALE: TStaticText;
    STDBU: TStaticText;
    STSHORT: TStaticText;
    STMED: TStaticText;
    STLONG: TStaticText;
    M10HZ: TMenuItem;
    M100HZ: TMenuItem;
    M1KHZ: TMenuItem;
    M1KHZT: TMenuItem;
    M36KHZT: TMenuItem;
    M100KHZT: TMenuItem;
    MenuItem4: TMenuItem;
    M1HZ: TMenuItem;
    MenuItem8: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    RXFreq: TStaticText;
    RXFreqTest: TLabel;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MRSTATE: TMenuItem;
    MMANCH: TMenuItem;
    MMANST: TMenuItem;
    MSCHANN: TMenuItem;
    MRXADD: TMenuItem;
    M9600B: TMenuItem;
    M38400B: TMenuItem;
    M57600B: TMenuItem;
    MSG: TMemo;
    MenuItem11: TMenuItem;
    MChannels: TMenuItem;
    MSHOWC: TMenuItem;
    MBlack: TMenuItem;
    MBlue: TMenuItem;
    MGreen: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MLEDC: TMenuItem;
    MenuItem9: TMenuItem;
    MENALL: TMenuItem;
    MGNULIC: TMenuItem;
    MABOUT: TMenuItem;
    MMAN: TMenuItem;
    MHelp: TMenuItem;
    MLSTATE: TMenuItem;
    MSSTATE: TMenuItem;
    MenuItem5: TMenuItem;
    MSmeter: TMenuItem;
    MenuItem1: TMenuItem;
    MCustom: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    SHKNOB1: TShape;
    SHKNOB: TShape;
    SPFREQ: TSpinEdit;
    STFM: TStaticText;
    STCW: TStaticText;
    STAM: TStaticText;
    STMAN: TStaticText;
    STUSB: TStaticText;
    STLSB: TStaticText;
    STISB: TStaticText;
    STCHAN: TStaticText;
    STFREQ: TStaticText;
    STREMOTE: TStaticText;
    STKHZ: TStaticText;
    STIND: TStaticText;
    STBFO: TStaticText;
    STTUNE: TStaticText;
    STSCAN: TStaticText;
    TBATTEN: TTrackBar;
    TSmeter: TTimer;
    TSMDISP: TTimer;
    B7: TButton;
    B8: TButton;
    B9: TButton;
    B4: TButton;
    B5: TButton;
    B6: TButton;
    B1: TButton;
    B2: TButton;
    B3: TButton;
    B0: TButton;
    MainMenu1: TMainMenu;
    MFile: TMenuItem;
    M19200B: TMenuItem;
    M115200B: TMenuItem;
    MExit: TMenuItem;
    MOptions: TMenuItem;
    MPort: TMenuItem;
    MSpeed: TMenuItem;
    MttyUSB0: TMenuItem;
    MttyUSB1: TMenuItem;
    procedure BCHANClick(Sender: TObject);
    procedure BCHSCANClick(Sender: TObject);
    procedure BCWClick(Sender: TObject);
    procedure BTUNEClick(Sender: TObject);
    procedure BENTERClick(Sender: TObject);
    procedure BSTOREClick(Sender: TObject);
    procedure BAMClick(Sender: TObject);
    procedure B4Click(Sender: TObject);
    procedure B7Click(Sender: TObject);
    procedure B8Click(Sender: TObject);
    procedure B9Click(Sender: TObject);
    procedure BFMClick(Sender: TObject);
    procedure BLSBClick(Sender: TObject);
    procedure B5Click(Sender: TObject);
    procedure B6Click(Sender: TObject);
    procedure B2Click(Sender: TObject);
    procedure B3Click(Sender: TObject);
    procedure B0Click(Sender: TObject);
    procedure BREMClick(Sender: TObject);
    procedure BRCLClick(Sender: TObject);
    procedure BBFOClick(Sender: TObject);
    procedure BFREQClick(Sender: TObject);
    procedure BISBClick(Sender: TObject);
    procedure BUSBClick(Sender: TObject);
    procedure CBAGCChange(Sender: TObject);
    procedure CBBWChange(Sender: TObject);
    procedure CBMODEChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: char);
    procedure MDEFSTClick(Sender: TObject);
    procedure M57600BClick(Sender: TObject);
    procedure M9600BClick(Sender: TObject);
    procedure M38400BClick(Sender: TObject);
    procedure MABOUTClick(Sender: TObject);
    procedure MENALLClick(Sender: TObject);
    procedure MKHZTClick(Sender: TObject);
    procedure MMANCHClick(Sender: TObject);
    procedure MMANSTClick(Sender: TObject);
    procedure MRSTATEClick(Sender: TObject);
    procedure MRXADDClick(Sender: TObject);
    procedure MSGDblClick(Sender: TObject);
    procedure MBlueClick(Sender: TObject);
    procedure MBlackClick(Sender: TObject);
    procedure MGNULICClick(Sender: TObject);
    procedure MLSTATEClick(Sender: TObject);
    procedure MMANClick(Sender: TObject);
    procedure MExitClick(Sender: TObject);
    procedure MSHOWCClick(Sender: TObject);
    procedure MSSTATEClick(Sender: TObject);
    procedure MSmeterClick(Sender: TObject);
    procedure MGreenClick(Sender: TObject);
    procedure MSTBITEClick(Sender: TObject);
    procedure MSTBITEFMClick(Sender: TObject);
    procedure RXfreqMouseUp(Sender: TObject; Button: TMouseButton;
            Shift: TShiftState; X, Y: Integer);
    procedure SHKNOB1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure SHKNOBMouseUp(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
    procedure SPFREQChange(Sender: TObject);
    procedure TBATTENChange(Sender: TObject);
    procedure TSMDISPTimer(Sender: TObject);
    procedure TSmeterTimer(Sender: TObject);
    procedure B1Click(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
            WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure M115200BClick(Sender: TObject);
    procedure M19200BClick(Sender: TObject);
    procedure MCustomClick(Sender: TObject);
    procedure MttyUSB0Click(Sender: TObject);
    procedure MttyUSB1Click(Sender: TObject);
    procedure KeyboardHandler(keyp: string);
    procedure DispRXf;
    procedure UpdateControls;
    function SendCommand(cmd, par: string): boolean;
    function OpenRemote: boolean;
    function CloseRemote: boolean;
    function SetRXFreq: boolean;
    procedure GetStatus;
    procedure LoadChannel(Sender: TObject);
    procedure RestoreState;
    procedure SaveConfig;
    procedure ReadConfig;
    procedure Message(ms: string);
    procedure DisableAllControls;
    procedure EnableAllControls;
    procedure SetActiveButtons;
    procedure CloseProgram;
    procedure LoadChannelsDir;
    procedure UpdateDisplay;
    procedure ParseStatus(Status: string);
    procedure DisableAllButtons;
    procedure DisableKeypad;
    procedure EnableKeypad;
    procedure EnableCmdKeys;
    procedure EnableCombosAndEdits;
    procedure SpinEditUpdateOnly(Sender: TObject; value: integer);
    function AdjustDecimalSeparator(s: string): string;
    function GetSelectedDigit(x,y: integer): integer;
    procedure GetDigitPosition;
    function GetReply: boolean;
    procedure ReadChanFile;
    procedure SaveChanFile;
    procedure SetColors(AColor: TCOlor);
    procedure GetLevel;
    procedure SetKeyCaptions(Mode: integer);

  private
    { private declarations }
    procedure DoMessages;
  public
    { public declarations }
  end;

Const
    // Version string
    SVersion:    string = 'v0.2 (C) 2014-2015 G. Perotti, I1EPJ';

    //
    // RA1792 command values (listener)
    //
    Set_Frequency:   string = 'F';     // in MHz downto 1 Hz, e.g. F12.345678
    Set_Mode:        string = 'D';     // 1..6 (AM, FM, CW, ISB, USB, LSB)
    Set_Bandwidth:   string = 'I';     // 1..5 (0.3, 1, 3, 6, 16 kHz)
    Set_AGC:         string = 'M';     // 1..7 (short, medium, long, manual,
                                       // short variable, medium variable,
                                       // long variable
    Set_BFO:         string = 'B';     // in kHz, 10 Hz step, range -8...+8 kHz
                                       // e.g. B1.23
    Set_Attenuation: string = 'A';     // IF attenuation, 3 digits, 000..150
    Start_BITE:      string = 'X';     // Starting BITE number, 2 digits

    //
    // RA1792 command values (talker)
    //
    Get_Status:       string = 'G';    // Get receiver status (all parameters)
    Get_Parameters:   string = 'T';    // Select returned parameters
                                       // (F, D, I, M, B, A, R)

    // PROLOGIX GPIP-USB Interface commands
    P_GetSetAddr:     string = '++addr';    // Set GPIB address
    P_GetSetMode:     string = '++mode';    // Set GPIB mode
    P_ResetInterface: string = '++rst';     // Reset GPIB interface

    // Filenames
    ConfigFileName: string = 'Config.dat';
    RXChanFileName: string = 'RXChan.dat';
    AUXFilename:    string = 'AUXconf.dat';

    // Messages
    COMMANDFAILED:  string = 'Command failed';
    RXCANTTUNE:     string = 'RX can''t tune to that frequency';

    // Mode values
    M_AM  = 1;
    M_FM  = 2;
    M_CW  = 3;
    M_ISB = 4;
    M_LSB = 5;
    M_USB = 6;

    // Filter values
    FILTER_300    = 1;
    FILTER_1000   = 2;
    FILTER_3200   = 3;
    FILTER_6000   = 4;
    FILTER_16000  = 5;

    // AGC values
    AGC_SHORT  = 1;
    AGC_MEDIUM = 2;
    AGC_LONG   = 3;
    AGC_MAN    = 4;
    AGC_MAN_SHORT = 5;
    AGC_MAN_MEDIUM = 6;
    AGC_MAN_LONG = 7;

      // frequency coverage
    MINRXF = 0;
    MAXRXF = 29999999;

    // special characters
    EOL: string = #$0d+#$0a;
    CR: char = #$0d;
    LF: char = #$0a;
    MeterChars = '»»»»»»»»»»»»';

    // TRUE/FALSE Constants
    ENABLED:  boolean = TRUE;
    DISABLED: boolean = FALSE;
    NOERROR:  boolean = TRUE;
    ERROR:    boolean = FALSE;
    NUMKEYS:  boolean = TRUE;
    FUNKEYS:  boolean = FALSE;

    // Timeout & delay values
    READTIMEOUT = 1000 * OneMillisecond;
    Delay100ms = 100 * OneMillisecond;

    // Keyboard states
    STATE_NORMAL = 1;
    STATE_SETFREQ = 2;
    STATE_SETBFO = 3;
    STATE_SELCHAN = 4;
    STATE_STOCHAN = 5;
    STATE_SCAN    = 6;
    STATE_BITE = 7;

    // Keyboard labels modes
    KBMODE_FUNKEYS   = 1;
    KBMODE_NUMKEYS   = 2;
    KBMODE_SCANDELAY = 3;

    // Display background color
    DispBackColor: TColor = $0a74ff;

Type
    TRXState = record
        Freq_rx: longint;
        Freq_step: integer;
        Mode_RX: integer;
        Filter: integer;
        AGC: integer;
        BFO: integer;
        Scan: boolean;
        IFGain: integer;
        BITEErr: integer;
        State: integer;
        Tune: boolean;
        ScanFlag: boolean;
    end;

    TRXChannels = array[0..99] of TRXState;

var
    RA1792: TRA1792;
    RXChannels: TRXChannels;

    RXState, OldRXState: TRXState;
    SerPort: TSerialHandle = 0;
    SerPortName: string = '/dev/ttyS0';
    SerPortSpeed: integer = 115200;
    SleepTime: integer;
    TimeOneCharMs: integer;
    RXAddress: integer = 1;
    s,t, dBm: integer;
    Status: string = '';
    sCHtmp: string;
    iCHnum: integer;
    LastChan: integer = 0;
    rCurChan: real;
    CurChan: integer;
    Enable_status: boolean = FALSE;
    In_Wheel: boolean = FALSE;
    In_Status: boolean = FALSE;
    In_RXFreqMouseUp: boolean = FALSE;
    In_TXFreqMouseUp: boolean = FALSE;
    In_Command: boolean = FALSE;
    Update_Only: boolean = FALSE;
    tmp: longint;
    HomeDir,StateDir,BandsDir,ChannelsDir: string;
    timeout: TTime;
    LEDColorOFF: TColor = clGreen;
    LEDColorON: TColor = ClLime;
    sLEDColor: string = 'green';
    HaveConfig: boolean = FALSE;
    n,m: integer;
    BandFileName: string;
    RemoteMode: string;
    CmdTag: integer = -1;
    PrevTag: integer = -1;
    DigitCoord: array[1..9, 1..2] of integer;
    sf,sd,si,sm,sb,sa,sx,sr,ss: string;
    KeyboardState: integer;
    DigitWidth: integer;
    prevalpha: real = 0;
    r, cx, cy,X2, Y2, R2: real;
    HzPerTurn: integer = 1000;
    SignalLevel: integer;
    OKPressed: boolean;
    ScanDelay: TTime = 2*Delay100ms;
    LastTuningTime: TTime;

implementation

{$R *.lfm}

{ TRA1792 }

//
// Auxiliary procedures & functions
//

// Adjust decimal separator in real number string
// Latest compilers do not accept anymore both separators (. and ,)
function TRA1792.AdjustDecimalSeparator(s: string): string;

var i: integer;

begin
    for i := 1 to Length(s) do
        if s[i]='.' then s[i] := DefaultFormatSettings.DecimalSeparator;
    AdjustDecimalSeparator := s;
end;

// Process message queue
procedure TRA1792.DoMessages;
begin
    Application.ProcessMessages;
end;

// Open communications
function TRA1792.OpenRemote: boolean;

var tmp: string;
    i,nc,len: integer;

begin
    {$IFDEF TEST_USER_INTERFACE}
     exit(NOERROR);
    {$ENDIF}

    // Init Prologix USB-to-GPIB interface

    tmp := P_GetSetMode+'1'+EOL;
    len := Length(tmp);
    nc := 0;
    for i := 1 to len do begin
        nc := nc + SerWrite(SerPort, tmp[i], 1);
        {$IFDEF LINUX}
        sleep(1);
        {$ENDIF}
        {$IFDEF WINDOWS}
        // under windows minimum sleep is 15ms
        sleep(0);
        {$ENDIF}
    end;
    if nc <> len then begin
        Message('Interface init failed');
        exit(ERROR);
    end;

    tmp := P_GetSetAddr+IntToStr(RXAddress)+EOL;
    len := Length(tmp);
    nc := 0;
    for i := 1 to len do begin
        nc := nc + SerWrite(SerPort, tmp[i], 1);
        {$IFDEF LINUX}
        sleep(1);
        {$ENDIF}
        {$IFDEF WINDOWS}
        // under windows minimum sleep is 15ms
        sleep(0);
        {$ENDIF}
    end;
    if nc <> len then begin
        Message('Interface init failed');
        exit(ERROR);
    end;

    // Check for RA1792 responding. Issue G command and wait for status reply
    Result := SendCommand(Get_Status,'');
    if Result then begin
        if GetReply then
            OpenRemote := NOERROR
        else
            OpenRemote := ERROR;
    end;
end;

// Close communications
function TRA1792.CloseRemote: boolean;
begin
    // ANYTHING TO DO?
    CloseRemote := TRUE;
end;

//Get reply to commands
function TRA1792.GetReply: boolean;

var buf: char;
    timeout: TTime;
    nc: integer;

begin
        buf := chr(0);
        Status := '';
        repeat
            timeout := time + READTIMEOUT;
            repeat
                nc := SerRead(SerPort, buf, 1);
                {$IFDEF LINUX}
                sleep(1);
                {$ENDIF}
                {$IFDEF WINDOWS}
                // under windows minimum sleep is 15ms
                sleep(0);
                {$ENDIF}
            until (nc > 0) or (time > timeout);
            Status := Status + buf;
        until (buf = LF) or (time > timeout);

        if time > timeout then GetReply := ERROR else GetReply := NOERROR;
end;

// Send a command to RA1792
function TRA1792.SendCommand(cmd, par: string): boolean;

var tmp: string;
    i,nc,len: integer;
    ok: boolean;

begin
    Enable_Status := DISABLED;

    tmp := cmd+par+EOL;
    len := Length(tmp);

    if MSHOWC.Checked then Message('Cmd: '+tmp);
    DoMessages;

    {$IFDEF TEST_USER_INTERFACE}
    exit(NOERROR);
    {$ENDIF}

    ok := NOERROR;
    nc := 0;
    for i := 1 to len do begin
        nc := nc + SerWrite(SerPort, tmp[i], 1);
{$IFDEF LINUX}
        sleep(1);
{$ENDIF}

{$IFDEF WINDOWS}
        sleep(0);
{$ENDIF}
    end;
    if nc <> len then begin
        Ok := ERROR;
        {$IFDEF TEST}
        Message('SerWrite returned ' + IntToStr(nc));
        {$ENDIF}
    end;

    if MSmeter.Checked then Enable_status := ENABLED;
    SendCommand := ok;
end;

// Get status
procedure TRA1792.GetStatus;

begin
    {$IFDEF TEST_USER_INTERFACE}
    status := 'F 18.070000D 3I 2M 7B 0.60A 000X 00S 1';
    exit;
    {$ENDIF}
    if SendCommand(Get_Status, '') then begin
        GetReply;
        ParseStatus(Status);
        {$IFDEF TEST}
        Message(Status);
        {$ENDIF}
        UpdateDisplay;
    end;
end;

// Get signal level
procedure TRA1792.GetLevel;

var i: integer;

begin
    if SendCommand(Get_Parameters, 'R') then begin
        GetReply;
        {$IFDEF TESTTR}
        Status := 'R 100'; // don't know if it is really so...
        {$ENDIF}
        // My RA1792 does not have the TR command, so this may likely not work...
        i := pos('R', Status);
        if i > 0 then begin
            sr := copy(Status, i+2, 3);
            SignalLevel := StrToInt(sr);
        end else begin
            sr := '';
            SignalLevel := 0;
            if Status = '' then
               Message('No reply to TR command, level reading disabled')
            else
                Message('Reply was: '+Status);
            TSmeter.Enabled := FALSE;
            TSMDISP.Enabled := FALSE;
            MSmeter.Checked := FALSE;
            Enable_Status := FALSE;
        end;
        {$IFDEF TEST}
        SignalLevel := random(150);
        {$ENDIF}
    end;
end;

// Parse status
procedure TRA1792.ParseStatus(Status: string);

var i: integer;
begin
    // Status is something like 'F 18.070000D 3I 2M 7B 0.60A 000X 00S 1'
    //                           00000000011111111112222222222333333333
    //                           12345678901234567890123456789012345678
    i := pos('F', Status);
    if i > 0 then begin
        sf := copy(Status, i+2, 9);
        RXState.Freq_rx := Trunc(StrToFloat(AdjustDecimalSeparator(sf))*1000000);
//      RXFreq.Caption := sf;
    end;

    i := pos('D', Status);
    if i > 0 then begin
        sd := copy(Status, i+2, 1);
        RXState.Mode_RX := StrToInt(sd);
    end else sd := '';

    i := pos('I', Status);
    if i > 0 then begin
        si := copy(Status, i+2, 1);
        RXState.Filter := StrToInt(si);
    end else si := '';

    i := pos('M', Status);
    if i > 0 then begin
        sm := copy(Status, i+2, 1);
        RXState.AGC := StrToInt(sm);
    end else sm := '';

    i := pos('B', Status);
    if i > 0 then begin
        sb := copy(Status, i+2, 4);
        RXState.BFO := Trunc(StrToFloat(AdjustDecimalSeparator(sb))*1000);
    end else sb := '';

    i := pos('A', Status);
    if i > 0 then begin
        sa := copy(Status, i+2, 3);
        RXState.IFGain := StrToInt(sa);
        TBAtten.Position := RXstate.IFGain;
    end else sa := '';

    i := pos('X', Status);
    if i > 0 then begin
        sx := copy(Status, i+2, 2);
        RXState.BITEErr := StrToInt(sx);
    end else sx := '';

    i := pos('S', Status);
    if i > 0 then begin
        ss := copy(Status, i+2, 1);
        RXState.State := StrToInt(ss);
    end else ss := '';

    // My RA1792 does not have the TR command, so this may likely not work...
    i := pos('R', Status);
    if i > 0 then begin
        sr := copy(Status, i+2, 3);
        SignalLevel := StrToInt(sr);
    end else begin
        sr := '';
        SignalLevel := 0;
    end;
end;

// Update display
procedure TRA1792.UpdateDisplay;

var s: string;

begin
    DispRXF;

    STFM.Visible := FALSE;
    STCW.Visible := FALSE;
    STAM.Visible := FALSE;
    STUSB.Visible := FALSE;
    STLSB.Visible := FALSE;
    STISB.Visible := FALSE;
    STBFOFR.Visible := FALSE;
    STBFO1.Visible := FALSE;
    STBFO2.Visible := FALSE;
    STSHORT.Visible := FALSE;
    STMED.Visible := FALSE;
    STLONG.Visible := FALSE;

    case RXState.Mode_RX of
        M_FM:  STFM.Visible := TRUE;
        M_AM:  STAM.Visible := TRUE;
        M_CW:  begin
            STCW.Visible := TRUE;
            STBFOFR.Visible := TRUE;
            STBFO1.Visible := TRUE;
            STBFO2.Visible := TRUE;
        end;
        M_LSB: STLSB.Visible := TRUE;
        M_USB: STUSB.Visible := TRUE;
        M_ISB: STISB.Visible := TRUE;
    end;

    case RXState.AGC of
        AGC_SHORT: begin
            STSHORT.Visible := TRUE;
            STMED.Visible := FALSE;
            STLONG.Visible := FALSE;
            STMAN.Visible := FALSE;
        end;
        AGC_MEDIUM: begin
            STSHORT.Visible := FALSE;
            STMED.Visible := TRUE;
            STLONG.Visible := FALSE;
            STMAN.Visible := FALSE;
        end;
        AGC_LONG: begin
            STSHORT.Visible := FALSE;
            STMED.Visible := FALSE;
            STLONG.Visible := TRUE;
            STMAN.Visible := FALSE;
        end;
        AGC_MAN_SHORT: begin
          STSHORT.Visible := TRUE;
          STMED.Visible := FALSE;
          STLONG.Visible := FALSE;
          STMAN.Visible := TRUE;
        end;
        AGC_MAN_MEDIUM: begin
          STSHORT.Visible := FALSE;
          STMED.Visible := TRUE;
          STLONG.Visible := FALSE;
          STMAN.Visible := TRUE;
        end;
        AGC_MAN_LONG: begin
          STSHORT.Visible := FALSE;
          STMED.Visible := FALSE;
          STLONG.Visible := TRUE;
          STMAN.Visible := TRUE;
        end;
    end;

    if RXstate.Tune then
       STTUNE.Visible := TRUE
    else
       STTUNE.Visible := FALSE;

    if si <> '' then begin
        STBW.Visible := TRUE;
        STBW1.Visible := TRUE;
        STBW2.Visible := TRUE;
    end else begin
      STBW.Visible := FALSE;
      STBW1.Visible := FALSE;
      STBW2.Visible := FALSE;
    end;

    case RXstate.Filter of
        FILTER_300:  STBW.Caption := '0.3';
        FILTER_1000: STBW.Caption := '1.0';
        FILTER_3200: STBW.Caption := '3.2';
        FILTER_6000: STBW.Caption := '6.0';
        FILTER_16000: STBW.Caption := '16';
    end;

    Str(RXState.BFO/1000:4:2, s);
    if RXState.BFO >= 0 then s := '+'+s;
    STBFOFR.Caption := s;

    case KeyboardState of
        STATE_NORMAL: begin
            STIND.Visible := FALSE;
            STSCAN.Visible := FALSE;
        end;
        STATE_SELCHAN: begin
            STIND.Visible := TRUE;
            STSCAN.Visible := FALSE;
            if RXState.ScanFlag then
                STSCAN.Visible := TRUE
            else
                STSCAN.Visible := FALSE;
        end;
        STATE_BITE: begin
            Message('Last BITE result: '+IntToStr(RXstate.BITEErr));
            KeyboardState := STATE_NORMAL;
            RXState := OldRXState;
            RestoreState;
        end;
    end;

    UpdateControls;
end;

// Set RX frequency
function TRA1792.SetRXFreq: boolean;

var  sf: string;
     rf: real;

begin
    rf := RXState.Freq_rx / 1000000;
    str(rf:9:6,sf);
    SendCommand(Set_Frequency, sf);
    OldRXState := RXState;
    SetRXFreq := NOERROR;
end;

// Display a message in MSG memo
procedure TRA1792.Message(ms: string);

var p: integer;
    tmp: string;

begin
    tmp := '';
    for p := 1 to length(ms) do begin
        if ms[p] = chr(13) then
            tmp := tmp+'[CR]'
        else if ms[p] = chr(10) then
            tmp := tmp+'[LF]'
        else
            tmp := tmp+ms[p];
    end;
    MSG.Lines.Add(tmp);
    DoMessages;
end;

// Clear messages in MSG memo
procedure TRA1792.MSGDblClick(Sender: TObject);
begin
        MSG.Lines.Clear;
end;

// Display only RX frequency
procedure TRA1792.DispRXf;

var tmp: real;
    s: string;

begin
    tmp := RXState.Freq_rx / 1000;
    str(tmp:9:3,s);
    RXFreq.Caption := s;
    SpinEditUpdateOnly(SPFREQ, RXState.Freq_RX);
end;

// Update non-button controls
procedure TRA1792.UpdateControls;

begin
    with RXState do begin
        SpinEditUpdateOnly(SPFREQ, Freq_rx);
        CBMODE.ItemIndex := Mode_RX - 1;
        CBBW.ItemIndex := Filter - 1;
        CBAGC.ItemIndex := AGC - 1;
    end;
end;

// Update SpinEdit display only
procedure TRA1792.SpinEditUpdateOnly(Sender: TObject; value: integer);

var ASpin: TSpinEdit;

begin
    ASpin := Sender as TSpinEdit;
    Update_Only := TRUE;
    ASpin.Value := Value;
    Update_Only := FALSE;
end;

// Keyboard handler
procedure TRA1792.KeyboardHandler(keyp: string);

var p: integer;
    s: string;
    f: longint;

begin
   case KeyboardState of
       STATE_NORMAL: {Nothing to do};
       STATE_SETFREQ: begin
           s := RXFreq.Caption;
           p := Pos('-',s);
           if p > 0 then begin
              s[p] := keyp[1];
              if s[p+1] = '.' then p := p+2 else p := p+1;
              f := trunc(1000*StrToFloat(AdjustDecimalSeparator(s)));
              if f > MAXRXF then begin
                  Message(RXCANTTUNE);
                  exit;
              end;
              if p <= Length(s) then s[p] := '-';
              RXFreq.Caption := s;
           end;
       end;
       STATE_SELCHAN, STATE_STOCHAN: begin
            sCHtmp[iCHNum] := keyp[1];
            iCHNum := iCHNum + 1;
            if iCHnum > 2 then iCHNum := 1;
            CHAN.Caption := sCHtmp;
       end;
   end;
end;

// Save RX channels file to disk
procedure TRA1792.SaveChanFile;

var RXChanFile: file of TRXChannels;

begin
    AssignFile(RXChanFile, HomeDir+RXChanFileName);
    {$I-}
    Rewrite(RXChanFile);
    {$I+}
    if IOResult = 0 then begin
        Write(RXChanFile, RXChannels);
        CloseFile(RXChanFile);
    end;
end;

// Read RX channels file from disk
procedure TRA1792.ReadChanFile;

var RXChanFile: file of TRXChannels;

begin
    AssignFile(RXChanFile, HomeDir+RXChanFileName);
    {$I-}
    Reset(RXChanFile);
    {$I+}
    if IOResult = 0 then begin
        Read(RXChanFile, RXChannels);
        CloseFile(RXChanFile);
    end;
end;

// Save config to disk
procedure TRA1792.SaveConfig;

var ConfigFile: Text;

begin
    AssignFile(ConfigFile, HomeDir+ConfigFileName);
    {$I-}
    Rewrite(ConfigFile);
    {$I+}
    if IOResult = 0 then begin
	    WriteLn(ConfigFile, SerPortName);
        Writeln(ConfigFile, SerPortSpeed);
        Writeln(ConfigFile, RXAddress);

        if MSmeter.Checked then
            WriteLn(ConfigFile,'TRUE')
        else
            WriteLn(ConfigFile, 'FALSE');

        if MSHOWC.Checked then
            WriteLn(ConfigFile,'TRUE')
        else
            WriteLn(ConfigFile, 'FALSE');
        if MENALL.Checked then
            WriteLn(ConfigFile,'TRUE')
        else
            WriteLn(ConfigFile, 'FALSE');

        WriteLn(ConfigFile,sLEDColor);

        if M1Hz.Checked then WriteLn(ConfigFile, '1');
        if M10Hz.Checked then WriteLn(ConfigFile, '10');
        if M100Hz.Checked then WriteLn(ConfigFile, '100');
        if M1kHz.Checked then WriteLn(ConfigFile, '1000');

        if MTIMED.Checked then
            WriteLn(ConfigFIle, '0')
        else
            WriteLn(ConfigFile, IntToStr(HzPerTurn));

        CloseFile(ConfigFile);
    end;
end;

// Read config from disk
procedure TRA1792.ReadConfig;

var ConfigFile: Text;
    s: string;
    i: integer;

begin
    AssignFile(ConfigFile, HomeDir+ConfigFileName);
    {$I-}
    Reset(ConfigFile);
    {$I+}
    if IOResult = 0 then begin
	    ReadLn(ConfigFile, SerPortName);
        ReadLn(ConfigFile, SerPortSpeed);
        ReadLn(ConfigFile, RXAddress);
        ReadLn(ConfigFile,s);
        MSmeter.Checked := (s = 'TRUE');
        ReadLn(ConfigFile,s);
        MSHOWC.Checked := (s = 'TRUE');
        ReadLn(ConfigFile,s);
        MENALL.Checked := (s = 'TRUE');
        ReadLn(ConfigFile,sLEDColor);
        ReadLn(ConfigFile, s);
        RXState.Freq_step := StrToInt(s);

        if sLEDColor = 'black' then begin
            LEDColorON := clBlack;
            MBlack.Checked := TRUE;
        end;
        if sLEDColor = 'green' then begin
            LEDColorON := clGreen;
            MGreen.Checked := TRUE;
        end;
        if sLEDColor = 'blue' then begin
            LEDColorON := clBlue;
            MBlue.Checked := TRUE;
        end;

        case RXState.Freq_step of
            1: M1Hz.Checked := TRUE;
            10: M10Hz.Checked := TRUE;
            100: M100Hz.Checked := TRUE;
            1000: M1kHz.Checked := TRUE;
            otherwise begin
                M1Hz.Checked := TRUE;
                RXState.Freq_Step := 1;
            end;
        end;

        ReadLn(ConfigFile, s);
        HzPerTurn := STrToInt(s);
        case HzPerTurn of
            0:      MTIMED.Checked := TRUE;
            500:    M0P5KHZT.Checked := TRUE;
            1000:   M1KHZT.Checked := TRUE;
            10000:  M36KHZT.Checked := TRUE;
            100000: M100KHZT.Checked := TRUE;
            otherwise begin
                HzPerTurn := 1000;
                M1KHZT.Checked := TRUE;
            end;
        end;

        CloseFile(ConfigFile);

        RXFreq.Font.Color := LEDColorON;
        CHAN.Font.Color := LEDColorON;
        for i := 1 to ComponentCount-1 do begin
            if Components[i] is TStaticText then
                (Components[i] as TStaticText).Font.Color := LEDColorON;
        end;
        STREMOTE.Font.Color := $0a74ff;
        STBFO.Font.Color := $0a74ff;
        STTUNE.Font.Color := $0a74ff;
        STSCAN.Font.Color := $0a74ff;
        STREMOTE.Color := LEDColorON;
        STBFO.Color := LEDColorON;
        STTUNE.Color := LEDColorON;
        STSCAN.Color := LEDColorON;
        STFM.Font.Color := $0a74ff;
        STAM.Font.Color := $0a74ff;
        STCW.Font.Color := $0a74ff;
        STUSB.Font.Color := $0a74ff;
        STLSB.Font.Color := $0a74ff;
        STISB.Font.Color := $0a74ff;
        STFM.Color := LEDColorON;
        STAM.Color := LEDColorON;
        STCW.Color := LEDColorON;
        STUSB.Color := LEDColorON;
        STLSB.Color := LEDColorON;
        STISB.Color := LEDColorON;
        STMET.Font.Color := LEDColorON;
        STSHORT.Font.Color := $0a74ff;
        STMED.Font.Color := $0a74ff;
        STLONG.Font.Color := $0a74ff;
        STMAN.Font.COlor := $0a74ff;
        STSHORT.Color := LEDColorON;
        STMED.Color := LEDColorON;
        STLONG.Color := LEDColorON;
        STMAN.COlor := LEDColorON;
    end else begin
        // default values
        {$IFDEF LINUX}
        SerPortName := '/dev/ttyUSB0';
        {$ENDIF}

        {$IFDEF WINDOWS}
        SerPortName := 'COM1';
        {$ENDIF}
        SerPortSpeed := 115200;
        MSmeter.Checked := FALSE;
        LEDColorOFF := $ff740a;
        LEDColorON := clBlack;
        sLEDColor := 'black';
        MGreen.Checked := FALSE;
        MBlack.Checked := FALSE;
        MBlue.Checked := TRUE;
        M115200B.Checked := TRUE;
        M1KHZ.Checked := TRUE;
        M1KHZT.Checked := TRUE;
    end;
    {$IFDEF LINUX}
    if SerPortName = '/dev/ttyUSB0' then begin
    {$ENDIF}

    {$IFDEF WINDOWS}
    if SerPortName = 'COM1' then begin
    {$ENDIF}
	    MttyUSB0.Checked := TRUE;
        MttyUSB1.Checked := FALSE;
        MCustom.Checked := FALSE;
    end else begin
        {$IFDEF LINUX}
        if SerPortName = '/dev/ttyUSB1' then begin
        {$ENDIF}
        {$IFDEF WINDOWS}
        if SerPortName = 'COM2' then begin
        {$ENDIF}
            MttyUSB0.Checked := FALSE;
            MttyUSB1.Checked := TRUE;
            MCustom.Checked := FALSE;
        end else begin
            MttyUSB0.Checked := FALSE;
            MttyUSB1.Checked := FALSE;
            MCustom.Checked := TRUE;
     	end;
    end;

    if SerPortSpeed = 9600 then M9600B.Checked := TRUE;
    if SerPortSpeed = 19200 then M19200B.Checked := TRUE;
    if SerPortSpeed = 38400 then M38400B.Checked := TRUE;
    if SerPortSpeed = 57600 then M57600B.Checked := TRUE;
    if SerPortSpeed = 115200 then M115200B.Checked := TRUE;
    MRXADD.Caption := 'Receiver address ('+IntToStr(RXAddress)+')';
    HaveConfig := TRUE;
end;

// Restore state in RXState
procedure TRA1792.RestoreState;

var par: string;
    r: real;

begin
    // Set RX frequency
    SpinEditUpdateOnly(SPFREQ, RXstate.Freq_RX);
    r := RXState.Freq_rx / 1000000;
    str(r:9:6,par);
    SendCommand(Set_Frequency, par);

    // Set mode
    if RXState.Mode_RX in [M_AM..M_USB] then begin
        par := IntToStr(RXState.Mode_RX);
    end else begin
        // Invalid value, default to A1
        RXState.Mode_RX := M_CW;
        par := '1';
    end;
    CBMode.ItemIndex := RXState.Mode_RX-1;
    if not SendCommand(Set_Mode, par) then
        Message(COMMANDFAILED);
    if (RXState.Mode_RX = M_LSB) or (RXstate.Mode_RX = M_USB) then
        CBBW.Enabled := FALSE;

    // Set filter
    if RXState.Filter in [Filter_300..Filter_16000] then begin
        CBBW.ItemIndex := RXState.Filter-1;
        par := IntToStr(RXState.Filter);
    end else begin
        // Invalid filter, assume 1000 Hz
        RXstate.Filter := Filter_1000;
        par := '2';
    end;
    if not SendCommand(Set_Bandwidth, par) then
        Message(COMMANDFAILED);

    // Set AGC
    if RXState.AGC in[AGC_SHORT..AGC_MAN_LONG] then begin
        par := IntToStr(RXstate.AGC);
        CBAGC.ItemIndex := RXState.AGC-1;
    end else begin
        // Invalid value, default to FAST
        RXState.AGC := AGC_LONG;
        par := '1';
    end;
    if not SendCommand(SET_AGC, par) then
        Message(COMMANDFAILED);

    // Status polling
    if MSmeter.Checked then begin
        TSmeter.Enabled := TRUE;
        In_Command := FALSE;
    end else begin
        TSmeter.Enabled := FALSE;
    end;

    // Scan mode
    if RXState.Scan then begin
        //TODO?
    end;

    // TUNE
    if RXstate.Tune then begin
        STTUNE.Visible := TRUE;
        SPFREQ.Enabled := TRUE;
    end else begin
        STTUNE.Visible := FALSE;
        SPFREQ.Enabled := FALSE;
    end;

    // Frequency step
    case RXstate.Freq_step of
           1: M1HZ.Checked := TRUE;
          10: M10HZ.Checked := TRUE;
         100: M100HZ.Checked := TRUE;
        1000: M1KHZ.Checked := TRUE;
    end;

    // Get and display new parameters
    GetStatus;
    UpdateDisplay;
    SetActiveButtons;
end;

//Create ordered Channels submenus
procedure TRA1792.LoadChannelsDir;

var m: TMenuItem;
    n: integer;
    Info: TSearchRec;
    FileList: TStringList;

begin
    FileList := TStringList.Create;
    FileList.Sorted := TRUE;
    if FindFirst(ChannelsDir+'*.dat', faAnyFile, info) = 0 then begin
        repeat
            delete(Info.Name, Length(Info.Name)-3, 4);
            FileList.Add(Info.Name);
        until FindNext(Info) <> 0;
        FindClose(Info);
        MChannels.Clear;
        for n := 0 to FileList.Count-1 do begin
            m := TmenuItem.Create(MChannels);
            m.Caption := FileList.Strings[n];
            m.OnClick := @LoadChannel;
            MChannels.Add(m);
        end;
        FileList.Clear;
        FileList.Free;
    end else begin
        MChannels.Clear;
        m := TmenuItem.Create(MChannels);
        m.Caption := 'No channels defined';
        MChannels.Add(m);
    end;
end;

// Load a channel file
procedure TRA1792.LoadChannel(Sender: TObject);

var BandFile: FILE of TRXState;

begin
    In_Command := TRUE;
    AssignFile(BandFile,ChannelsDir+(Sender as TMenuItem).Caption+'.dat');
    {$I-}
    Reset(BandFile);
    {$I+}
    if IOResult = 0 then begin
        Read(BandFile,RXState);
        CloseFile(BandFile);
    end else Message('Can''t open channel file');
    RestoreState;
    UpdateDisplay;
    In_Command := FALSE;
end;

// Disable all controls except EXT and some menus
procedure TRA1792.DisableAllControls;

var i: integer;

begin
    for i := 0 to ComponentCount - 1 do begin
	    if Components[i] is TControl then begin
            if (Components[i] is TStaticText) then
                TControl(Components[i]).Visible := FALSE
            else
                TControl(Components[i]).Enabled := FALSE;
		end;
    end;
    MLState.Enabled := FALSE;
    MSState.Enabled := FALSE;
    MSCHANN.Enabled := FALSE;
    MRSTATE.Enabled := FALSE;
    MSmeter.Enabled := FALSE;
    MChannels.Enabled := FALSE;
    MPORT.Enabled := TRUE;
    MSPEED.Enabled := TRUE;
    MRXADD.Enabled := TRUE;
    MttyUSB0.Enabled := TRUE;
    MttyUSB1.Enabled := TRUE;
    MCustom.Enabled := TRUE;
    M9600B.Enabled := TRUE;
    M19200B.Enabled := TRUE;
    M38400B.Enabled := TRUE;
    M57600B.Enabled := TRUE;
    M115200B.Enabled := TRUE;
    BREM.Enabled := TRUE;
    RXFreq.Enabled := TRUE;
    STCHAN.Enabled := TRUE;
end;

// Disable all buttons
procedure TRA1792.DisableAllButtons;

var i: integer;

begin
    if MENALL.Checked then exit;
	for i := 0 to ComponentCount - 1 do begin
		if Components[i] is TBitBtn then
	   	    TBitBtn(Components[i]).Enabled := FALSE;
		if Components[i] is TButton then
	   		TButton(Components[i]).Enabled := FALSE;
		if Components[i] is TSpinEdit then
	   		TSpinEdit(Components[i]).Enabled := FALSE;
		if Components[i] is TComboBox then
	   		TComboBox(Components[i]).Enabled := FALSE;
	end;
end;

// Disable numeric keypad buttons
procedure TRA1792.DisableKeypad;

begin
    if MENALL.Checked then exit;
    B0.Enabled := FALSE;
    B1.Enabled := FALSE;
    B2.Enabled := FALSE;
    B3.Enabled := FALSE;
    B4.Enabled := FALSE;
    B5.Enabled := FALSE;
    B6.Enabled := FALSE;
    B7.Enabled := FALSE;
    B8.Enabled := FALSE;
    B9.Enabled := FALSE;
    BSTORE.Enabled := FALSE;
    BENTER.Enabled := FALSE;
end;

// Enable numeric keypad buttons
procedure TRA1792.EnableKeypad;

begin
    B0.Enabled := TRUE;
    B1.Enabled := TRUE;
    B2.Enabled := TRUE;
    B3.Enabled := TRUE;
    B4.Enabled := TRUE;
    B5.Enabled := TRUE;
    B6.Enabled := TRUE;
    B7.Enabled := TRUE;
    B8.Enabled := TRUE;
    B9.Enabled := TRUE;
end;

// Enable command keys
procedure TRA1792.EnableCmdKeys;

begin
    BREM.Enabled := TRUE;
    BRCL.Enabled := TRUE;
    BBFO.Enabled := TRUE;
    BUSB.Enabled := TRUE;
    BCHAN.Enabled := TRUE;
    BFREQ.Enabled := TRUE;
    BISB.Enabled := TRUE;
    BLSB.Enabled := TRUE;
    BTUNE.Enabled := TRUE;
    BAM.Enabled := TRUE;
    BCW.Enabled := TRUE;
    BFM.Enabled := TRUE;
    BCHSCAN.Enabled := TRUE;
end;

// Enable Combo and Edit boxes
procedure TRA1792.EnableCombosAndEdits;
begin
    SPFREQ.Enabled := TRUE;
    CBMODE.Enabled := TRUE;
    CBBW.Enabled := TRUE;
    CBAGC.Enabled := TRUE;
end;

// Set numbers or functions key captions
procedure TRA1792.SetKeyCaptions(Mode: integer);

begin
    case Mode of
        KBMODE_FUNKEYS: begin
            // Function keys captions
            B0.Caption := 'AUX';
            B1.Caption := 'BW1';
            B2.Caption := 'BW2';
            B3.Caption := 'BW3';
            B4.Caption := 'BW4';
            B5.Caption := 'BW5';
            B6.Caption := 'MAN';
            B7.Caption := 'SHORT';
            B8.Caption := 'MED';
            B9.Caption := 'LONG';
        end;
        KBMODE_NUMKEYS: begin
            // Numeric keys captions
            B0.Caption := '0';
            B1.Caption := '1';
            B2.Caption := '2';
            B3.Caption := '3';
            B4.Caption := '4';
            B5.Caption := '5';
            B6.Caption := '6';
            B7.Caption := '7';
            B8.Caption := '8';
            B9.Caption := '9';
        end;
        KBMODE_SCANDELAY: begin
          B0.Caption := '0.1s';
          B1.Caption := '0.2s';
          B2.Caption := '0.5s';
          B3.Caption := '0.8s';
          B4.Caption := '1s';
          B5.Caption := '2s';
          B6.Caption := '4s';
          B7.Caption := '6s';
          B8.Caption := '8s';
          B9.Caption := '10s';
        end;
    end;
end;

// Enable all controls
procedure TRA1792.EnableAllControls;

var i: integer;

begin
    for i := 0 to ComponentCount - 1 do begin
	    if Components[i] is TControl then begin
  	        TControl(Components[i]).Enabled := TRUE;
        end;
       	if Components[i] is TMenuItem then begin
           TMenuItem(Components[i]).Enabled := TRUE;
	    end;
       	if Components[i] is TSpinEdit then begin
           TSpinEdit(Components[i]).Enabled := TRUE;
	    end;
       	if Components[i] is TComboBox then begin
           TComboBox(Components[i]).Enabled := TRUE;
	    end;
       	if Components[i] is TShape then begin
           TShape(Components[i]).Visible := TRUE;
	    end;
    end;
    if MSmeter.Checked then begin
        TSmeter.Enabled := TRUE;
    end;
    RXFreq.Visible := TRUE;
    STREMOTE.Visible := TRUE;
    STTUNE.Visible := RXState.Tune;
    STSCALE.Visible := TRUE;
    STRF.Visible := TRUE;
    STDBU.Visible := TRUE;
    STRF.Visible := TRUE;
    STMET.Visible := TRUE;
    STKHZ.Visible := TRUE;
    STFREQ.Visible := TRUE;
    DoMessages;
end;

// Set active/not active buttons & edit state
procedure TRA1792.SetActiveButtons;

begin
    if MENALL.Checked then
        // Do not try to disable inactive buttons, so do nothing and return
        exit
    else begin

        case KeyboardState of
            STATE_NORMAL: begin
              EnableAllControls;
              EnableKeypad;
              if not RXState.Tune then SPFREQ.Enabled := FALSE;
              if not (RXState.Mode_RX in [M_AM, M_CW, M_FM]) then CBBW.Enabled := FALSE;
              if RXState.Mode_RX in [M_USB, M_LSB] then begin
                  B4.Enabled := FALSE;
                  B5.Enabled := FALSE;
              end;
            end;
            STATE_SETFREQ: begin
              DisableAllButtons;
              EnableKeypad;
              BRCL.Enabled := TRUE;
              BFREQ.Enabled := TRUE;
              BENTER.Enabled := TRUE;
            end;
            STATE_SELCHAN: begin
              DisableAllButtons;
              EnableKeypad;
              BRCL.Enabled := TRUE;
              BCHSCAN.Enabled := TRUE;
              BENTER.Enabled := TRUE;
            end;
            STATE_STOCHAN: begin
              DisableAllButtons;
              EnableKeypad;
              BENTER.Enabled := TRUE;
            end;
            STATE_SETBFO: begin
              DisableAllButtons;
              BBFO.Enabled := TRUE;
              BENTER.Enabled := TRUE;
            end;
            STATE_SCAN: begin
              BREM.Enabled := FALSE;
              BBFO.Enabled := FALSE;
              BTUNE.Enabled := FALSE;
              BSTORE.Enabled := FALSE;
              BENTER.Enabled := FALSE;
              BFREQ.Enabled := FALSE;
              BCHAN.Enabled := FALSE;
              BRCL.Enabled := FALSE;
              BISB.Enabled := FALSE;
              BLSB.Enabled := FALSE;
              BUSB.Enabled := FALSE;
              BAM.Enabled := FALSE;
              BCW.Enabled := FALSE;
              BFM.Enabled := FALSE;
              BCHSCAN.Enabled := TRUE;
            end;
            STATE_BITE: begin
              DisableAllButtons;
              BENTER.Enabled := TRUE;
            end;
        end;
    end;
end;


//
// Object init & functions
//

// Various initializations at startup
procedure TRA1792.FormCreate(Sender: TObject);

{$IFDEF WINDOWS}
var i: integer;
{$ENDIF}

begin
    {$IFDEF TEST_USER_INTERFACE}
    RA1792.Caption := 'RA1792 Control - USER INTERFACE TEST MODE!';
    {$ENDIF}

    {$IFDEF WINDOWS}
    // Serial ports names
    MttyUSB0.Caption := 'COM1';
    MttyUSB1.Caption := 'COM2';

    // Set black color for button text
    // (Under Windows buttons can't be colored)
	for i := 0 to ComponentCount - 1 do begin
		if Components[i] is TBitBtn then
	   	    TBitBtn(Components[i]).Font.Color := clBlack;
		if Components[i] is TButton then
	   		TButton(Components[i]).Font.Color := clBlack;
	end;
    {$ENDIF}

    RXFreq.Caption := '';
    STMET.Caption := '';
    DisableAllControls;

    // Read channels directory
    LoadChannelsDir;

    // Read config
    ReadConfig;

     // Calculate fixed parameters for tuning knob
    r := (SHKNOB1.Width - SHKNOB.Width) / 2;
    cx := SHKNOB1.Left+(SHKNOB1.Width - SHKNOB.Width) / 2;
    cy := SHKNOB1.Top+(SHKNOB1.Height -SHKNOB.Height) / 2;
    X2 := SHKNOB1.Width / 2;
    Y2 := SHKNOB1.Height / 2;
    R2 := SHKNOB1.Width / 2;

    {$IFDEF LINUX}
    BCHSCAN.Caption := 'CHAN'+LineEnding+'SCAN';
    {$ENDIF}
end;

// Close down program
procedure TRA1792.CloseProgram;
begin
    if MSmeter.Checked then begin
        TSmeter.Enabled := FALSE;
        Enable_Status := FALSE;
    end;
    if SerPort > 0 then begin
        SerFlush(SerPort);
        SerClose(SerPort);
    end;
    if HaveConfig then SaveConfig;
    Halt;
end;

// Closing by clicking on X
procedure TRA1792.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
    CloseAction := caNone;
    MExitClick(Sender);
end;

// Allows to enter commands using the keyboard
procedure TRA1792.FormKeyPress(Sender: TObject; var Key: char);

var f: integer;

begin
    if In_Status or SPFREQ.Focused then exit;

    {$IFDEF TEST}
    Message('Key pressed: '+''''+Key+'''');
    {$ENDIF}

    case LowerCase(Key) of
        'u': BUSBCLick(Sender);
        'l': BLSBClick(Sender);
        'c': BCWClick(Sender);
        'a': BAMClick(Sender);
        'f': BFMClick(Sender);
        'i': BISBClick(Sender);
        'b': begin
          RXstate.Filter := RXstate.Filter+1;
          if RXstate.Filter > FILTER_16000 then RXState.Filter := FILTER_300;
          RestoreState;
          UpdateDisplay;
        end;

        '0': B0Click(Sender);
        '1': B1Click(Sender);
        '2': B2Click(Sender);
        '3': B3Click(Sender);
        '4': B4Click(Sender);
        '5': B5Click(Sender);
        '6': B6Click(Sender);
        '7': B7Click(Sender);
        '8': B8Click(Sender);
        '9': B9Click(Sender);

        '*': BFREQCLick(Sender);
        #$0D: BENTERCLick(Sender);

        '+': begin
            if RXstate.Tune then begin
                f := RXState.Freq_rx + RXState.Freq_step;
                if f <= MAXRXF then begin
                    RXState.Freq_rx := f;
                    SetRXFreq;
                    UpdateDisplay;
                end;
            end;
        end;
        '-': begin
            if RXstate.Tune then begin
                f := RXstate.Freq_rx - RXstate.Freq_step;
                if f >= MINRXF then begin
                    RXState.Freq_rx := f;
                    SetRXFreq;
                    UpdateDisplay;
                end;
            end;
        end;
        '/': begin
            if M1HZ.Checked then MDEFSTClick(M10HZ)
            else if M10HZ.Checked then MDEFSTClick(M100HZ)
            else if M100HZ.Checked then MDEFSTClick(M1KHZ)
            else if M1KHZ.Checked then MDEFSTClick(M1HZ);
        end;
        '.': BTUNEClick(Sender);
    end;
    key := #0;
end;


//
// Menu handling
//

// "File" menu handling

// "Load state"
procedure TRA1792.MLSTATEClick(Sender: TObject);

var StateFile: FILE of TRXState;

begin
    OpenDialog1.InitialDir := StateDir;
    if OpenDialog1.Execute then begin
        AssignFile(StateFile,OpenDialog1.Filename);
        {$I-}
        Reset(StateFile);
        {$I+}
        if IOResult = 0 then begin
            Read(StateFile,RXState);
            CloseFile(StateFile);
        end else Message('Can''t open file');
        RestoreState;
        UpdateControls;
    end;
end;

// "Save state" or "Save channel"
procedure TRA1792.MSSTATEClick(Sender: TObject);

var StateFile: file of TRXState;
    SModeRX: string = '';
    sMtmp,sFtmp: string;

begin
    case RXState.Mode_RX of
        M_ISB: SModeRX := 'ISB';
        M_USB: SModeRX := 'USB';
        M_LSB: SmodeRX := 'LSB';
        M_AM:  SModeRX := 'AM';
        M_CW:  SModeRX := 'CW';
        M_FM:  SModeRX := 'FM';
    end;

    sMtmp := sModeRX;
    sFtmp := RXFreq.Caption;

    if Sender = MSSTATE then SaveDialog1.InitialDir := StateDir;
    if Sender = MSCHANN then SaveDialog1.InitialDir := ChannelsDir;
    SaveDialog1.FileName := sFtmp + '-' + sMtmp + '.dat';
    if SaveDialog1.Execute then begin
        AssignFile(StateFile,SaveDialog1.Filename);
        {$I-}
        Rewrite(StateFile);
        {$I+}
        if IOResult = 0 then begin
            Write(StateFile,RXState);
            CloseFile(StateFile);
        end;
    end;
    if Sender = MSCHANN then LoadChannelsDir;
end;

// "Manage channels"
procedure TRA1792.MMANCHClick(Sender: TObject);
begin
    UMGR.Caption := 'Channel Manager';
    UMGR.TFLB.Directory := ChannelsDir;
    UMGR.TFLB.UpdateFileList;
    UMGR.Tag := 1;
    UMGR.Show;
end;

// "Manage States"
procedure TRA1792.MMANSTClick(Sender: TObject);
begin
    UMGR.Caption := 'State Manager';
    UMGR.TFLB.Directory := StateDir;
    UMGR.TFLB.UpdateFileList;
    UMGR.Tag := 0;
    UMGR.Show;
end;

// "Restore current state"
procedure TRA1792.MRSTATEClick(Sender: TObject);

begin
    RestoreState;
    EnableAllControls;
    UpdateControls;
    UpdateDisplay;
    SetActiveButtons;
end;

// "Exit"
procedure TRA1792.MExitClick(Sender: TObject);
begin
    SaveConfig;
    SaveChanFile;
    if MessageDlg('Close program','Really exit?',mtConfirmation,
                  [mbYES, mbNO],0) = mrYES then CloseProgram;
end;

//
// "Other functions" menu handling
//

// "Start BITE"
procedure TRA1792.MSTBITEClick(Sender: TObject);
begin
    OldRXState := RXState;
    SendCommand(Start_BITE,'001');
    KeyboardState := STATE_BITE;
    SetActiveButtons;
end;

// "Start BITE from..."
procedure TRA1792.MSTBITEFMClick(Sender: TObject);

var StartTestNo, err: integer;

begin
    OldRXState := RXState;
    repeat
        OKPressed := FALSE;
        FEntTestNo.Show;
        Val(FEntTestno.EDTESTNO.Text, StartTestNo, err);
        DoMessages;
    until OKPressed and (err=0);
    SendCommand(Start_BITE, IntToStr(StartTestNo));
    KeyboardState := STATE_BITE;
    SetActiveButtons;
end;

//
// "Options" menu handling
//

// "RS232 port"

// "ttyUSB0"
procedure TRA1792.MttyUSB0Click(Sender: TObject);

begin
    {$IFDEF LINUX}
    SerPortName := '/dev/ttyUSB0';
    {$ENDIF}

    {$IFDEF WINDOWS}
    SerPortName := 'COM1';
    {$ENDIF}
    SaveConfig;
end;

// "ttyUSB1"
procedure TRA1792.MttyUSB1Click(Sender: TObject);

begin
    {$IFDEF LINUX}
    SerPortName := '/dev/ttyUSB1';
    {$ENDIF}

    {$IFDEF WINDOWS}
    SerPortName := 'COM2';
    {$ENDIF}
    SaveConfig;
end;

// "Custom..."
procedure TRA1792.MCustomClick(Sender: TObject);
begin
    FSerport.Show;
    FSerport.Eser.Text := SerPortName;
end;

// "RS232 speed"
// Does not matter for the Prologix USB-to-GPIB interface
// but may be required for other interfaces

// 9600 baud
procedure TRA1792.M9600BClick(Sender: TObject);
begin
    SerPortSpeed := 9600;
    SaveConfig;
    TimeOneCharMs := 11000 div SerPortSpeed;
    SleepTime := 70-(TimeOneCharMs);
end;

// "19200 baud"
procedure TRA1792.M19200BClick(Sender: TObject);
begin
    SerPortSpeed := 19200;
    SaveConfig;
    TimeOneCharMs := 11000 div SerPortSpeed;
    SleepTime := 70-(TimeOneCharMs);
end;

// "38400 baud"
procedure TRA1792.M38400BClick(Sender: TObject);
begin
    SerPortSpeed := 38400;
    SaveConfig;
    TimeOneCharMs := 11000 div SerPortSpeed;
    SleepTime := 70-(TimeOneCharMs);
end;

// "57600 baud"
procedure TRA1792.M57600BClick(Sender: TObject);
begin
    SerPortSpeed := 57600;
    SaveConfig;
    TimeOneCharMs := 11000 div SerPortSpeed;
    SleepTime := 70-(TimeOneCharMs);
end;

// "115200 baud"
procedure TRA1792.M115200BClick(Sender: TObject);
begin
    SerPortSpeed := 115200;
    SaveConfig;
    TimeOneCharMs := 11000 div SerPortSpeed;
    SleepTime := 70-(TimeOneCharMs);
end;

// "Receiver address"
procedure TRA1792.MRXADDClick(Sender: TObject);
begin
    FADDR.SPRXADD.Value := RXAddress;
    FADDR.Show;
end;

// Set kHz per turn
procedure TRA1792.MKHZTClick(Sender: TObject);
begin
     HzPerTurn := (Sender as TmenuItem).Tag;
end;

// Set default step (for mouse sheel and + - keys)
procedure TRA1792.MDEFSTClick(Sender: TObject);
begin
    RXstate.Freq_step := (Sender as TMenuItem).Tag;
    case RXState.Freq_step of
        1: M1HZ.Checked := TRUE;
        10: M10Hz.Checked := TRUE;
        100: M100HZ.Checked := TRUE;
        1000: M1KHZ.Checked := TRUE;
    end;
    Message('Default step '+IntTostr(RXState.Freq_step)+'Hz');
end;

// "Enable S-Meter"
procedure TRA1792.MSmeterClick(Sender: TObject);
begin
    MSmeter.Checked := not MSmeter.checked;
    SaveConfig;
    UpdateControls;
    if MSmeter.Checked then begin
        TSmeter.Enabled := TRUE;
        TSMDISP.Enabled := TRUE;
        Enable_Status := TRUE;
    end else begin
        TSmeter.Enabled := FALSE;
        TSMDISP.Enabled := FALSE;
        Enable_Status := FALSE;
    end;
end;

// "LED Color"

// Set display colors
procedure TRA1792.SetColors(AColor: TColor);
begin
    RXFreq.Font.Color := AColor;
    CHAN.Font.Color := AColor;
    STCHAN.Font.Color := AColor;
    STFREQ.Font.Color := AColor;
    STREMOTE.Color := AColor;
    STKHZ.Font.Color := AColor;
    STIND.Font.Color := AColor;
    STTUNE.Color := AColor;
    STSCAN.Color := AColor;
    STFM.Color := AColor;
    STAM.Color := AColor;
    STCW.Color := AColor;
    STUSB.Color := AColor;
    STLSB.Color := AColor;
    STISB.Color := AColor;
    STSHORT.Color := AColor;
    STMAN.Color := AColor;
    STMED.Color := AColor;
    STLONG.Color := AColor;
    STRF.Font.Color := AColor;
    STMET.Font.Color := AColor;
    STDBU.Font.Color := AColor;
    STSCALE.Font.Color := AColor;
    STBFO.Color := AColor;
    STBFO1.Font.Color := AColor;
    STBFO2.Font.Color := AColor;
    STBFOFR.Font.color := AColor;
    STBW.Font.Color := AColor;
    STBW1.Font.Color := AColor;
    STBW2.Font.Color := AColor;
    STFAULT.COlor := AColor;
    STMUTE.COlor := AColor;
end;

// "Blue"
procedure TRA1792.MBlueClick(Sender: TObject);
begin
    MBlack.Checked := FALSE;
    MBlue.Checked := TRUE;
    MGreen.Checked := FALSE;
    LEDCOlorOFF := clGreen;
    LEDColorON := clBlue;
    sLEDColor := 'blue';
    SetColors(LEDColorON);
    SaveConfig;
    UpdateControls;
end;

// "Green"
procedure TRA1792.MGreenClick(Sender: TObject);
begin
    MBlack.Checked := FALSE;
    MBlue.Checked := FALSE;
    MGreen.Checked := TRUE;
    LEDCOlorOFF := clGray;
    LEDColorON := clGreen;
    sLEDColor := 'green';
    SetColors(LEDColorON);
    SaveConfig;
    UpdateControls;
end;

// "Black"
procedure TRA1792.MBlackClick(Sender: TObject);
begin
    MBlack.Checked := TRUE;
    MBlue.Checked := FALSE;
    MGreen.Checked := FALSE;
    LEDCOlorOFF := clGray;
    LEDColorON := clBlack;
    sLEDColor := 'black';
    SetColors(LEDColorON);
    SaveConfig;
    UpdateControls;
end;

// "Enable all controls"
procedure TRA1792.MENALLClick(Sender: TObject);
begin
    MENALL.Checked := not MENALL.Checked;
    SaveConfig;
    if SerPort <> 0 then begin
        if MENALL.Checked then EnableAllControls else SetActiveButtons;
        UpdateControls;
    end;
end;

// "Show commands"
procedure TRA1792.MSHOWCClick(Sender: TObject);
begin
    MSHOWC.Checked := not MSHOWC.Checked;
    SaveConfig;
end;


//
// "Channels" menu is dinamically built
// See procedure LoadChannelsDir
//

//
// "Help" menu handling
//

// "About"
procedure TRA1792.MABOUTClick(Sender: TObject);

begin
    FAbout.Show;
end;

// "Manual"
procedure TRA1792.MMANClick(Sender: TObject);

begin
    FMAN.Show;
end;

// "GNU License"
procedure TRA1792.MGNULICClick(Sender: TObject);
begin
    FGNU.Show;
end;

//
// Buttons handling (block 1)
//

// REM
procedure TRA1792.BREMClick(Sender: TObject);
begin
    if In_Command then exit;
    In_Command := TRUE;
    if SerPort > 0 then begin
        if MSmeter.Checked then begin
          TSmeter.Enabled := FALSE;
          Enable_Status := FALSE;
          TSMDISP.Enabled := FALSE;
        end;
        CloseRemote;
        SerFlush(SerPort);
        SerClose(SerPort);
        SerPort := 0;
        SaveConfig;
        SaveChanFile;
        RXFreq.Caption := '';
        TSmeter.Enabled := FALSE;
        DisableAllControls;
    end else begin
        KeyboardState := STATE_NORMAL;
        GetDigitPosition;
        MSG.Lines.Clear;
        ReadConfig;
        ReadChanFile;
	    SerPort := SerOpen(SerPortName);
        if SerPort > 0 then begin
            SerSetParams(SerPort,SerPortSpeed,8,NoneParity,1,[]);
            SerSetDTR(SerPort, TRUE);
            SerSetRTS(SerPort, TRUE);

            if OpenRemote then begin
                {$IFDEF TEST}
                Message(Status);
                {$ENDIF}
                EnableAllControls;
                EnableKeypad;
                SetKeyCaptions(KBMODE_FUNKEYS);
                ParseStatus(Status);
                OldRXState := RXState;
                DoMessages;
                UpdateDisplay;
                SetActiveButtons;
                if MSmeter.Checked then begin
                    TSmeter.Enabled := TRUE;
                    Enable_Status := TRUE;
                    TSMDISP.Enabled := TRUE;
                end else begin
                    TSmeter.Enabled := FALSE;
                    Enable_Status := FALSE;
                    TSMDISP.Enabled := FALSE;
                end;
                RXstate.Tune := FALSE;
                STTUNE.Visible := FALSE;
                SPFREQ.Enabled := FALSE;
                if (RXState.Mode_RX = M_LSB) or (RXstate.Mode_RX = M_USB) then
                    CBBW.Enabled := FALSE;
            end else begin
                SerFlush(SerPort);
                SerClose(SerPort);
                SerPort := 0;
                if MessageDlg('Error',
                    'Failed to initialize communications.'
                    +LineEnding
                    +'Retry?',
                    mtConfirmation, [mbYES, mbNO],0) = mrNO then begin
                    CloseProgram;
               end else begin
                 In_Command := FALSE;
                 BREMClick(Sender);
               end;
            end;
	    end else begin
            if MessageDlg('Error',
                'Unable to open serial port "'
                +SerPortname
                +'".'
                +LineEnding
                +'Check name and user privileges.'
                + LineEnding
                +'Retry?',
                mtConfirmation, [mbYES, mbNO],0) = mrNO then begin
                CloseProgram
            end else begin
                In_Command := FALSE;
            end;
        end
    end;
    In_Command := FALSE;
end;

// BFO
procedure TRA1792.BBFOClick(Sender: TObject);
begin
    if KeyboardState = STATE_NORMAL then begin
        KeyboardState := STATE_SETBFO;
        STBFO.Visible := TRUE;
        Message('Set BFO frequency');
    end else begin
        KeyboardState := STATE_NORMAL;
        STBFO.Visible := FALSE;
    end;
    SetActiveButtons;
end;

// TUNE
procedure TRA1792.BTUNEClick(Sender: TObject);
begin
    RXState.Tune := not RXState.Tune;
    if RXState.Tune then begin
        STTUNE.Visible := TRUE;
        SPFREQ.Enabled := TRUE;
    end else begin
      STTUNE.Visible := FALSE;
      SPFREQ.Enabled := FALSE;
    end;
    STCHAN.Visible := FALSE;
    CHAN.Visible := FALSE;
end;

//
// Buttons handling (block 2)
//


// "1/BW1"
procedure TRA1792.B1Click(Sender: TObject);
begin
    if In_Command then exit;
    In_Command := TRUE;
    case KeyboardState of
        STATE_NORMAL: begin
            while not SendCommand(Set_Bandwidth, IntToStr(Filter_300)) do;
            RXState.Filter := FILTER_300;
            UpdateDisplay;
        end;
        STATE_SETFREQ, STATE_SETBFO, STATE_SELCHAN, STATE_STOCHAN: begin
            KeyboardHandler('1');
        end;
        STATE_SCAN: begin
            ScanDelay := 2*Delay100ms;
            Message('Scan delay 0.2s');
        end;
    end;
    In_Command := FALSE;
end;

// "2/BW2"
procedure TRA1792.B2Click(Sender: TObject);
begin
    if In_Command then exit;
    In_Command := TRUE;
    case KeyboardState of
        STATE_NORMAL: begin
            while not SendCommand(Set_Bandwidth, IntToStr(Filter_1000)) do;
            RXState.Filter := FILTER_1000;
            UpdateDisplay;
        end;
        STATE_SETFREQ, STATE_SETBFO, STATE_SELCHAN, STATE_STOCHAN: begin
            KeyboardHandler('2');
        end;
        STATE_SCAN: begin
            ScanDelay := 5*Delay100ms;
            Message('Scan delay 0.5s');
        end;
    end;
    In_Command := FALSE;
end;

// "3/BW3"
procedure TRA1792.B3Click(Sender: TObject);
begin
    if In_Command then exit;
    In_Command := TRUE;
    case KeyboardState of
        STATE_NORMAL: begin
            while not SendCommand(Set_Bandwidth, IntToStr(Filter_3200)) do;
            RXState.Filter := FILTER_3200;
            UpdateDisplay;
        end;
        STATE_SETFREQ, STATE_SETBFO, STATE_SELCHAN, STATE_STOCHAN: begin
            KeyboardHandler('3');
        end;
        STATE_SCAN: begin
            ScanDelay := 8*Delay100ms;
            Message('Scan delay 0.8s');
        end;
    end;
    In_Command := FALSE;
end;

// "4/BW4"
procedure TRA1792.B4Click(Sender: TObject);
begin
    if In_Command then exit;
    In_Command := TRUE;
    case KeyboardState of
        STATE_NORMAL: begin
            while not SendCommand(Set_Bandwidth, IntToStr(Filter_6000)) do;
            RXState.Filter := FILTER_6000;
            UpdateDisplay;
        end;
        STATE_SETFREQ, STATE_SETBFO, STATE_SELCHAN, STATE_STOCHAN: begin
            KeyboardHandler('4');
        end;
        STATE_SCAN: begin
            ScanDelay := 10*Delay100ms;
            Message('Scan delay 1s');
        end;
    end;
    In_Command := FALSE;
end;

// "5/BW5"
procedure TRA1792.B5Click(Sender: TObject);
begin
    if In_Command then exit;
    In_Command := TRUE;
    case KeyboardState of
        STATE_NORMAL: begin
            while not SendCommand(Set_Bandwidth, IntToStr(Filter_16000)) do;
            RXState.Filter := FILTER_16000;
            UpdateDisplay;
        end;
        STATE_SETFREQ, STATE_SETBFO, STATE_SELCHAN, STATE_STOCHAN: begin
            KeyboardHandler('5');
        end;
        STATE_SCAN: begin
            ScanDelay := 20*Delay100ms;
            Message('Scan delay 2s');
        end;
    end;
    In_Command := FALSE;
end;

// "6/MAN"
procedure TRA1792.B6Click(Sender: TObject);

var spar: string;
    ipar: integer;

begin
    if In_Command then exit;
    In_Command := TRUE;
    case KeyboardState of
        STATE_NORMAL: begin
            case RXState.AGC of
                AGC_SHORT, AGC_MEDIUM, AGC_LONG:
                  ipar := RXState.AGC+AGC_MAN;
                AGC_MAN_SHORT, AGC_MAN_MEDIUM, AGC_MAN_LONG:
                  ipar := RXState.AGC-AGC_MAN;
                AGC_MAN: ipar := AGC_MAN;
            end;
            spar := IntToStr(ipar);
            RXState.AGC := ipar;
            while not SendCommand(Set_AGC, spar) do;
            UpdateDisplay;
        end;
        STATE_SETFREQ, STATE_SETBFO, STATE_SELCHAN, STATE_STOCHAN: begin
            KeyboardHandler('6');
        end;
        STATE_SCAN: begin
            ScanDelay := 40*Delay100ms;
            Message('Scan delay 4s');
        end;
    end;
    In_Command := FALSE;
end;

// "7/SHORT"
procedure TRA1792.B7Click(Sender: TObject);

var spar: string;
    ipar: integer;

begin
    if In_Command then exit;
    In_Command := TRUE;
    case KeyboardState of
        STATE_NORMAL: begin
            case RXState.AGC of
                AGC_SHORT, AGC_MEDIUM, AGC_LONG:
                  ipar := AGC_SHORT;
                AGC_MAN_SHORT:
                  ipar := AGC_MAN;
                AGC_MAN_MEDIUM, AGC_MAN_LONG:
                  ipar := AGC_MAN + AGC_SHORT;
                AGC_MAN: ipar := AGC_MAN+AGC_SHORT;
            end;
            spar := IntToStr(ipar);
            RXState.AGC := ipar;
            while not SendCommand(Set_AGC, spar) do;
            UpdateDisplay;
        end;
        STATE_SETFREQ, STATE_SETBFO, STATE_SELCHAN, STATE_STOCHAN: begin
            KeyboardHandler('7');
        end;
        STATE_SCAN: begin
            ScanDelay := 60*Delay100ms;
            Message('Scan delay 6s');
        end;
    end;
    In_Command := FALSE;
end;

// "8/MED"
procedure TRA1792.B8Click(Sender: TObject);

var spar: string;
    ipar: integer;

begin
    if In_Command then exit;
    In_Command := TRUE;
    case KeyboardState of
        STATE_NORMAL: begin
            case RXState.AGC of
               AGC_SHORT, AGC_MEDIUM, AGC_LONG:
                 ipar := AGC_MEDIUM;
               AGC_MAN_SHORT, AGC_MAN_LONG:
                 ipar := AGC_MAN + AGC_MEDIUM;
               AGC_MAN_MEDIUM:
                 ipar := AGC_MAN;
               AGC_MAN: ipar := AGC_MAN+AGC_MEDIUM;
           end;
           spar := IntToStr(ipar);
           RXState.AGC := ipar;
           while not SendCommand(Set_AGC, spar) do;
           UpdateDisplay;
        end;
        STATE_SETFREQ, STATE_SETBFO, STATE_SELCHAN, STATE_STOCHAN: begin
            KeyboardHandler('8');
        end;
        STATE_SCAN: begin
            ScanDelay := 80*Delay100ms;
            Message('Scan delay 8s');
        end;
    end;
    In_Command := FALSE;
end;

// "9/LONG"
procedure TRA1792.B9Click(Sender: TObject);

var spar: string;
    ipar: integer;

begin
    if In_Command then exit;
    In_Command := TRUE;
    case KeyboardState of
        STATE_NORMAL: begin
           case RXState.AGC of
              AGC_SHORT, AGC_MEDIUM, AGC_LONG:
                ipar := AGC_LONG;
              AGC_MAN_SHORT, AGC_MAN_MEDIUM:
                ipar := AGC_MAN + AGC_LONG;
              AGC_MAN_LONG:
                  ipar := AGC_MAN;
              AGC_MAN: ipar := AGC_MAN+AGC_LONG;
          end;
          spar := IntToStr(ipar);
          RXState.AGC := ipar;
          while not SendCommand(Set_AGC, spar) do;
          UpdateDisplay;
      end;
        STATE_SETFREQ, STATE_SETBFO, STATE_SELCHAN, STATE_STOCHAN: begin
            KeyboardHandler('9');
        end;
        STATE_SCAN: begin
            ScanDelay := 100*Delay100ms;
            Message('Scan delay 10s');
        end;
    end;
    In_Command := FALSE;
end;

// "Store"
procedure TRA1792.BSTOREClick(Sender: TObject);
begin
    case KeyboardState of
        STATE_NORMAL: begin
            KeyboardState := STATE_STOCHAN;
            STCHAN.Visible := TRUE;
            CHAN.Visible := TRUE;
            iCHNum := 1;
            sCHTmp := '  ';
            CHAN.Caption := sCHTmp;
            SetKeyCaptions(KBMODE_NUMKEYS);
        end;
        STATE_STOCHAN: begin
            BEnterClick(Sender);
        end;
    end;
end;

// "0/AUX"
procedure TRA1792.B0Click(Sender: TObject);

var tmpRXState: TRXState;
    AUXFile: file of TRXstate;

begin
    if In_Command then exit;
    In_Command := TRUE;
    case KeyboardState of
        STATE_NORMAL: begin
          AssignFile(AUXFile, Homedir+AUXFileName);
          {$I-}
          Reset(AUXFile);
          {$I+}
          if IOResult <> 0 then begin
              Message('No AUX file saved');
          end else begin
              Read(AUXFile,tmpRXState);
              CloseFile(AUXFile);
              RXState.Mode_RX := tmpRXState.Mode_RX;
              RXstate.Filter := tmpRXState.Filter;
              RXstate.AGC := tmpRXState.AGC;
              RXState.BFO := tmpRXState.BFO;
              RestoreState;
          end;
        end;
        STATE_SETFREQ, STATE_SETBFO, STATE_SELCHAN, STATE_STOCHAN: begin
            KeyboardHandler('0');
        end;
        STATE_SCAN: begin
            ScanDelay := Delay100ms;
            Message('Scan delay 0.1s');
        end;
    end;
    In_Command := FALSE;
end;

// "ENTER"
procedure TRA1792.BENTERClick(Sender: TObject);

var p, chnum: integer;
    s: string;

begin
    In_Command := TRUE;
    case KeyboardState of
        STATE_SETFREQ: begin
            s := RXFreq.Caption;
            p := pos('-',s);
            if p <> 0 then s[p] := '0';
            RXState.Freq_rx := Trunc(1000*StrToFloat(AdjustDecimalSeparator(s)));
            SetRXfreq;
            SetKeyCaptions(KBMODE_FUNKEYS);
            KeyboardState := STATE_NORMAL;
       end;
        STATE_SELCHAN: begin
            chnum := StrToInt(CHAN.Caption);
            RXstate := RXChannels[chnum];
            if not ((RXstate.Freq_step in [1,10,100]) or (RXstate.Freq_step=1000)) then
                RXState.Freq_step := 100;
            RXState.Tune := FALSE;
            LastChan := chnum;
            RestoreState;
            STCHAN.Visible := FALSE;
            CHAN.Visible := FALSE;
            SetKeyCaptions(KBMODE_FUNKEYS);
            KeyboardState := STATE_NORMAL;
        end;
        STATE_STOCHAN: begin
          chnum := StrToInt(CHAN.Caption);
          RXChannels[chnum] := RXState;
          LastChan := chnum;
          rCurChan := chnum;
          KeyboardState := STATE_SELCHAN;
        end;
        STATE_BITE: begin
          GetStatus;
        end;
    end;
    UpdateDisplay;
    SetActiveButtons;
    In_Command := FALSE;
end;

// FREQ
procedure TRA1792.BFREQClick(Sender: TObject);

begin
    SetKeyCaptions(KBMODE_NUMKEYS);
    RXFreq.Caption := '-0000.000';
    KeyboardState := STATE_SETFREQ;
    STIND.Visible := TRUE;
    RXState.Tune := FALSE;
    STTUNE.Visible := FALSE;
    SetActiveButtons;
    Message('Enter frequency in kHz');
end;

// CHAN
procedure TRA1792.BCHANClick(Sender: TObject);
begin
    KeyboardState := STATE_SELCHAN;
    STCHAN.Visible := TRUE;
    CHAN.Visible := TRUE;
    STIND.Visible := TRUE;
    STTUNE.Visible := FALSE;
    OldRXState := RXState;
    RXState := RXChannels[LastChan];
    SetKeyCaptions(KBMODE_NUMKEYS);
    SetActiveButtons;
    UpdateDisplay;
    iCHNum := 1;
    sCHTmp := IntToStr(LastChan);
    rCurChan := LastChan;
    if Length(sCHTmp) = 1 then sCHtmp := '0'+sCHTmp;
    Message('Enter channel# (0..99)');
end;

// RCL
procedure TRA1792.BRCLClick(Sender: TObject);
begin
    if In_Command then exit;
    In_Command := TRUE;
    RXState := OldRXState;
    KeyboardState := STATE_NORMAL;
    SetKeyCaptions(KBMODE_FUNKEYS);
    STCHAN.Visible := FALSE;
    CHAN.Visible := FALSE;
    RXstate.Tune := FALSE;
    RestoreState;
    SetActiveButtons;
    UpdateDisplay;
    In_Command := FALSE;
end;

//
// Buttons handling (block 3)
//

// "ISB"
procedure TRA1792.BISBClick(Sender: TObject);
begin
    if In_Command then exit;
    In_Command := TRUE;
    while not SendCommand(Set_Mode, '4') do;
    RXState.Mode_RX := M_ISB;
    SetActiveButtons;
    GetStatus;
    UpdateDisplay;
    In_Command := FALSE;
end;

// "LSB"
procedure TRA1792.BLSBClick(Sender: TObject);

begin
    if In_Command then exit;
    In_Command := TRUE;
    while not SendCommand(Set_Mode, '5') do;
        RXState.Mode_RX := M_LSB;
    SetActiveButtons;
    GetStatus;
    UpdateDisplay;
    In_Command := FALSE;
end;

// "USB"
procedure TRA1792.BUSBClick(Sender: TObject);
begin
    if In_Command then exit;
    In_Command := TRUE;
    while not SendCommand(Set_Mode, '6') do;
    RXState.Mode_RX := M_USB;
    SetActiveButtons;
    GetStatus;
    UpdateDisplay;
    In_Command := FALSE;
end;

// "AM"
procedure TRA1792.BAMClick(Sender: TObject);
begin
    if In_Command then exit;
    In_Command := TRUE;
    while not SendCommand(Set_Mode, '1') do;
    RXState.Mode_RX := M_AM;
    SetActiveButtons;
    GetStatus;
    UpdateDisplay;
    In_Command := FALSE;
end;

// "CW"
procedure TRA1792.BCWClick(Sender: TObject);
begin
    if In_Command then exit;
    In_Command := TRUE;
    while not SendCommand(Set_Mode, '3') do;
    RXState.Mode_RX := M_CW;
    SetActiveButtons;
    GetStatus;
    UpdateDisplay;
    In_Command := FALSE;
end;

// "FM"
procedure TRA1792.BFMClick(Sender: TObject);
begin
    if In_Command then exit;
    In_Command := TRUE;
    while not SendCommand(Set_Mode, '2') do;
    RXState.Mode_RX := M_FM;
    SetActiveButtons;
    GetStatus;
    UpdateDisplay;
    In_Command := FALSE;
end;

//
// Buttons handling (block 4)
//

// "CHAN SCAN"
procedure TRA1792.BCHSCANClick(Sender: TObject);

var i: integer;
    t: TTime;
    SomeChanScanned: boolean = FALSE;

begin
    case KeyboardState of
        STATE_NORMAL: begin
          KeyboardState := STATE_SCAN;
          SetActiveButtons;
          SetKeyCaptions(KBMODE_SCANDELAY);
          OldRXState := RXState;
          i := 0;
          STSCAN.Visible := TRUE;
          while KeyBoardState = STATE_SCAN do begin
            if RXChannels[i].ScanFlag then begin
                SomeChanScanned := TRUE;
                RXState := RXChannels[i];
                RestoreState;
                UpdateDisplay;
                t := Time+ScanDelay;
            end;
            while Time < t do DoMessages;
            i := i + 1;
            if i > 99 then begin
                if SomeChanScanned then
                    i := 0
                else begin
                    Message('No channels with SCAN flag set found');
                    BCHSCANClick(Sender);
                end;
            end;
          end;
        end;
        STATE_SCAN: begin
          KeyboardState := STATE_NORMAL;
          STSCAN.Visible := FALSE;
          SetActiveButtons;
          SetKeyCaptions(KBMODE_FUNKEYS);
        end;
        STATE_SELCHAN: begin
           RXChannels[CurChan].ScanFlag := not RXChannels[CurChan].ScanFlag;
           if RXChannels[CurChan].ScanFlag then
               STSCAN.Visible := TRUE
           else
               STSCAN.Visible := FALSE;
        end;
    end;
end;


//
// ComboBox & SpinEdit
//

// AGC ComboBox
procedure TRA1792.CBAGCChange(Sender: TObject);
begin
    In_Command := TRUE;
    while not SendCommand(Set_AGC, IntToStr(CBAGC.ItemIndex+1)) do;
    RXstate.AGC := CBAGC.ItemIndex+1;
    EnableCmdKeys;
    EnableCombosAndEdits;
    UpdateDisplay;
    In_Command := FALSE;
end;

// BANDWIDTH ComboBox
procedure TRA1792.CBBWChange(Sender: TObject);
begin
    In_Command := TRUE;
    while not SendCommand(Set_Bandwidth, IntToStr(CBBW.ItemIndex+1)) do;
    RXState.Filter := CBBW.ItemIndex+1;
    EnableCmdKeys;
    EnableCombosAndEdits;
    UpdateDisplay;
    In_Command := FALSE;
end;

// MODE ComboBox
procedure TRA1792.CBMODEChange(Sender: TObject);

begin
    In_Command := TRUE;
    while not SendCommand(Set_Mode, IntToStr(CBMODE.ItemIndex+1)) do;
    RXstate.Mode_RX := CBMODE.ItemIndex+1;
    GetStatus;
    UpdateDisplay;
    EnableCmdKeys;
    EnableCombosAndEdits;
    SetActiveButtons;
    In_Command := FALSE;
end;

// Frequency SpinEdit
procedure TRA1792.SPFREQChange(Sender: TObject);
begin
    {$IFDEF LINUX}
    if Update_Only or In_Command or (not RXState.Tune) then exit;
    In_Command := TRUE;
    {$ENDIF}
    {$IFDEF WINDOWS}
    // Under Windows the OnChange event fires also when it shouldnt
    if Update_Only or (RXState.Freq_RX = SPFREQ.Value) then exit;
    {$ENDIF}
    RXState.Freq_RX := SPFREQ.Value;
    SetRXFreq;
    UpdateDisplay;
    In_Command := FALSE;
end;

// Attenuation slider
procedure TRA1792.TBATTENChange(Sender: TObject);

var s: string;

begin
    s := IntToStr(TBATTEN.Position);
    while Length(s) < 3 do s := '0'+s;
    SendCommand(Set_Attenuation, s);
    {$IFDEF TEST}
    itmp := (12*TBatten.Position) div 150;
    s := Copy(MeterChars, 1, 2*itmp);
    STMET.Caption := s;
    {$ENDIF}
end;

// Returns frequency digit over which is the mouse pointer
function TRA1792.GetSelectedDigit(x,y: integer): integer;

var i: integer;

begin
    if (y > 0) and (y < RXFreq.Height) then begin
        GetSelectedDigit := -1;
        for i := 1 to 9 do begin
            if (x >= DigitCoord[i,1]) and (x < DigitCoord[i,2]) then exit(i);
        end;
    end;
end;

// Get size of frequency display and calculate position of digits
procedure TRA1792.GetDigitPosition;

var i: integer;

begin
    // Must do this on a test TLabel (TStaticText does not follow Autosize)
    RXFreqTest.Visible := TRUE;
    RXFreqTest.Caption := '29999.999';
    DigitWidth := RXFreqTest.Width div 9;
    {$IFDEF TEST}
    Message('Digit width: '+inttostr(RXFreqTest.Width));
    RXFreqTest.Caption := '29999.999';
    RXFreqWidth := RXFreqTest.Width;
    Message('''29999.999'' width: '+inttostr(RXFreqWidth));
    {$ENDIF}
    for i := 1 to 9 do begin
        DigitCoord[i,1] := (i-1)*(DigitWidth);
        DigitCoord[i,2] := (i)*(DigitWidth);
    end;
    RXFreqTest.Visible := FALSE;
end;

// Alternative frequency setting way: left/right click on the frequency figures
// Clicking on the decimal point rewrites displayed frequency
procedure TRA1792.RXfreqMouseUp(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);

var step: integer;

begin
    if In_Command or In_RXFreqMouseUp or (not RXstate.Tune) then exit;

    {$IFDEF TEST}
    Message('X='+IntToStr(X)+' Y='+IntTostr(Y));
    {$ENDIF}

    In_RXFreqMouseUp := TRUE;
    case GetSelectedDigit(X,Y) of
        1: step := 10000000;
        2: step := 1000000;
        3: step := 100000;
	    4: step := 10000;
        5: step := 1000;
        6: step := 0;	// click on decimal point
	    7: step := 100;
        8: step := 10;
        9: step := 1;
        otherwise begin
           In_RXFreqMouseUp := FALSE;
           exit;
        end;
    end;
    if Button = mbLeft then begin
        if RXState.Freq_rx - step >= MINRXF then
	   RXState.Freq_rx := RXState.Freq_rx-step;
	end;
    if Button = mbRight then begin
        if RXState.Freq_rx + step <= MAXRXF then
	   RXState.Freq_rx := RXState.Freq_rx+step;
	end;
    if not SetRXFreq then
        Message(COMMANDFAILED);
    DispRXf;

    In_RXFreqMouseUp := FALSE;
end;

// Third tuning mode: simulated tuning knob
procedure TRA1792.SHKNOB1MouseMove(Sender: TObject; Shift: TShiftState; X,
    Y: Integer);

var alpha, dalpha, myx, myy, deltatms: real;
    tmpstep,step,direction: integer;
    s: string;
    t: TTime;

begin
    if In_Command or not (RXstate.Tune or
       (KeyboardState in [STATE_SETBFO..STATE_STOCHAN])) then exit;

    t := Time;
    deltatms := (t-LastTuningTime)/OneMillisecond;
    LastTuningTime := t;

    {$IFDEF TEST}
    Message('deltat = '+IntToStr(trunc(deltatms))+ ' ms');
    {$ENDIF}

    if deltatms>300 then deltatms := 300;

    {$IFDEF TEST}
    Message('step = '+IntToStr(step)+ ' Hz');
    {$ENDIF}

    if (sqr(X-X2)+sqr(Y-Y2)) > sqr(R2) then exit;

    In_Command := TRUE;
    alpha := arctan2(Y-SHKNOB1.Height / 2, X - SHKNOB1.Width / 2);
    myx := r * cos(alpha) + cx;
    myy := r * sin(alpha) + cy;
    SHKNOB.Top := trunc(myy);
    SHKNOB.Left := trunc(myx);
    {$IFDEF TEST}
    Message('alpha='+floatTostr(alpha)+' prevalpha='+floatTostr(prevalpha));
    {$ENDIF}
    alpha := alpha+pi; // make angle interval positive (0..2*pi)
    dalpha := alpha-prevalpha;
    if (dalpha) < -pi then begin
        prevalpha := 0;   // (2*pi) --> 0
        dalpha := alpha-prevalpha;
    end;
    if (dalpha) > pi then begin
        prevalpha := 2*pi; // 0 --> 2*pi
        dalpha := alpha-prevalpha;
    end;
    if dalpha > 0 then direction := 1 else direction := -1;
    tmpstep := trunc(HzPerTurn*((dalpha)/(2*pi)));
    prevalpha := alpha;

    if MTIMED.Checked then begin
        step := trunc((301-deltatms)*direction);
    end else begin
        step := tmpstep;
    end;
    case KeyboardState of
        STATE_NORMAL: begin
            RXState.Freq_RX := RXState.Freq_rx+step;
            SetRXFreq;
            DispRXF;
        end;
        STATE_SETBFO: begin
            if step > 0 then step := 10 else step := -10;
            RXstate.BFO := RXstate.BFO + step;
            if RXstate.BFO > 8000 then RXState.BFO := 8000;
            if RXstate.BFO < -8000 then RXState.BFO := -8000;
            Str(RXState.BFO/1000:4:2, s);
            SendCommand(Set_BFO, s);
            UpdateDisplay;
        end;
        STATE_SELCHAN, STATE_STOCHAN: begin
            if step > 0 then
               rCurChan := rCurChan + 0.2
            else
               rCurChan := rCurChan - 0.2;
            if rCurChan < 0 then rCurChan := 99;
            if rCurChan > 99 then rCurChan := 0;
            CurChan := trunc(rCurChan);
            s := Format('%2.2D',[CurChan]);
            CHAN.Caption := s;
            LastChan := CurChan;
            if KeyboardState = STATE_SELCHAN then
                RXState := RXChannels[CurChan];
            UpdateDisplay;
        end;
    end;
    In_Command := FALSE;
end;

// Click on the tunign knob hole
procedure TRA1792.SHKNOBMouseUp(Sender: TObject; Button: TMouseButton;
    Shift: TShiftState; X, Y: Integer);
begin
    case KeyboardState of
        STATE_NORMAL: begin
            RXState.Tune := not RXState.Tune;
            if RXstate.Tune then begin
             SPFREQ.Enabled := TRUE;
             LastTuningTime := Time;
            end else
            SPFREQ.Enabled := FALSE;
            UpdateDisplay;
        end;
        STATE_SELCHAN: BENTERClick(Sender);
        STATE_STOCHAN: BENTERClick(Sender);
        STATE_SETBFO: BBFOCLick(Sender);
    end;
end;

// Allows to use mouse wheel for tuning
procedure TRA1792.FormMouseWheel(Sender: TObject; Shift: TShiftState;
        WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);

var step: integer = -1;
    Xrel, Yrel: integer;

begin
    if In_Wheel or In_Status or (not RXState.Tune) then exit;
    In_Wheel := TRUE;
    {$IFDEF TEST}
    Message('X='+IntToStr(MousePos.X)+' Y='+IntTostr(MousePos.Y));
    {$ENDIF}
    // Calculate relative cursor position
    Xrel := MousePos.X - RXFreq.Left - Panel1.Left;
    Yrel := MousePos.Y - RXFreq.Top;

    // Set step size if cursor over RX frequency display
    case GetSelectedDigit(Xrel, Yrel) of
        1: step := 10000000;
        2: step := 1000000;
        3: step := 100000;
	4: step := 10000;
        5: step := 1000;
        6: step := 0;	// wheel on decimal point
	7: step := 100;
        8: step := 10;
        9: step := 1;
        otherwise begin
            if not (MousePos.Y in [44..74]) then begin
                if WheelDelta > 0 then begin
                    if RXState.Freq_rx+RXState.Freq_step <= MAXRXF then begin
                        RXState.Freq_rx := RXState.Freq_rx + RXState.Freq_step;
                        if SetRXFreq then begin
                            GetStatus;
                            ParseStatus(status);
                            UpdateDisplay;
                        end else Message(COMMANDFAILED);
                    end else Message(RXCANTTUNE);
                end;
                if WheelDelta < 0 then begin
                    if RXState.Freq_rx-RXState.Freq_step >= MINRXF then begin
                        RXState.Freq_rx := RXState.Freq_rx - RXState.Freq_step;
                        if SetRXFreq then begin
                            GetStatus;
                            ParseStatus(status);
                            UpdateDisplay;
                        end else Message(COMMANDFAILED);
                    end else Message(RXCANTTUNE);
                end;
            end;
            In_Wheel := FALSE;
            exit;
        end;
     end;

     // Mouse wheel over RX frequency display
    if WheelDelta > 0 then begin
        if step >= 0 then begin
	        if RXState.Freq_rx + step <= MAXRXF then begin
                RXState.Freq_rx := RXState.Freq_rx + step;
                if not SetRXFreq then Message(COMMANDFAILED);
            end else Message(RXCANTTUNE);
        end;
    end;
    if WheelDelta < 0 then begin
        if step >= 0 then begin
	        if RXState.Freq_rx - step >= MINRXF then begin
                RXState.Freq_rx := RXState.Freq_rx-step;
                if not SetRXFreq then Message(COMMANDFAILED);
            end else Message(RXCANTTUNE);
        end;
    end;
    UpdateDisplay;
    SpinEditUpdateOnly(SPFREQ, RXstate.Freq_RX);

    Handled := TRUE;
    In_Wheel := FALSE;
end;

//
// Timers
//

// Status timer. Get signal level every 300 ms.
// May not work, my RA1792 does not have the level reading command.
// Level is returned also in response to G command or in TR command only?
procedure TRA1792.TSmeterTimer(Sender: TObject);

begin
    if Enable_Status then begin
        if In_Status or In_Command then exit;
        In_Status := TRUE;
        status := '';
        GetLevel;
        In_Status := FALSE;
    end;
end;

// Display signal level every 300 ms
// Manual says RF level is 0..150, why not 0..120?
procedure TRA1792.TSMDISPTimer(Sender: TObject);

var itmp: integer;
    s: string;

begin
    {$IFDEF TEST_USER_INTERFACE}
    SignalLevel := 100+random(50);
    {$ENDIF}
    itmp := (12*SignalLevel) div 150;
    s := Copy(MeterChars, 1, 2*itmp);
    STMET.Caption := s;
end;

// Things to do at startup
initialization

begin
    {$IFDEF LINUX}
    HomeDir := GetUserDir+'.RA1792Control/';
   	StateDir := HomeDir+'States/';
    ChannelsDir := HomeDir+'Channels/';
    {$ENDIF}
    {$IFDEF WINDOWS}
    HomeDir := GetUserDir+'RA1792Control\';
    StateDir := HomeDir+'States\';
    ChannelsDir := HomeDir+'Channels\';
    {$ENDIF}
   	if not DirectoryExists(HomeDir) then CreateDir(HomeDir);
   	if not DirectoryExists(StateDir) then CreateDir(StateDir);
    if not DirectoryExists(BandsDir) then CreateDir(BandsDir);
    if not DirectoryExists(ChannelsDir) then CreateDir(ChannelsDir);
end;

end.

